/* UniThorpe <strick@yak.net> Gnu GPL */

#include "unithorpe3.h"

int hi(th x) { // hi byte, as printable char
	int y= (ISINT(x)) ? ((x>>8)&255) : 0;
	return (32<=y && y<=126) ? y : '.';
}
int lo(th x) { // lo byte, as printable char
	int y= (ISINT(x)) ? ((x)&255) : 0;
	return (32<=y && y<=126) ? y : '.';
}

thingy bomb(char* s, thingy x) {
	fflush(stdout);
	fprintf(stderr, "ABORT: %s (%lu)\n", s, x);
	fflush(stderr);
	abort();
	/*NOTREACHED*/
	return 0;
}

void* alloc(int n) {
	void* p;
	do {
		p= calloc( n, 1 );
		if (!p) bomb("nomem", n);
	} while (ISINT(p));
P("@@ alloc %d -> %lu\n", n, p);
	return p;
}

void freez(void* p, int n) {
P("@@ free -> %lu // ", p);
{ int i; for (i= 0; i<6; i++) { P( "%lu ", ((thingy*)p)[i] ); } }
P("\n");

	memset( p, 0xFA, n );  // FAFAFAF...
	free(p);
}

#define INITIAL_CAP 16

thingy anew() {
	arr* p= (arr*) alloc( sizeof *p );
	if (!p) bomb("nomem", sizeof *p );
	p->rc= 0;
	p->cap= INITIAL_CAP;
	p->p= (th*) alloc( INITIAL_CAP * sizeof(th) );
	return (thingy)p;
}


thingy aget(thingy a, thingy i) {
//P( "get %lu,%lu ", a, i );
	arr* p= ARR(a);
	int j= INT(i);
	return ( j < p->cap ) ? ( p->p[j] ) : 0;

}

void aput(thingy a, thingy i, thingy x) {
//P( "put<%lu,%lu,%lu>\n", a, i, x );
	arr* p= ARR(a);
	int j= INT(i);

	if ( j >= p->cap ) {

	    int newcap= 2 * p->cap;
	    while ( j >= newcap )
		newcap *= 2;

	    p->p = realloc( p->p, newcap*sizeof(th) );
	    memset( p->p + p->cap, 0, (newcap - p->cap) * sizeof(th) );
	    p->cap= newcap;
	}

	CHANGE( p->p[j], x);
}

void alink(thingy a) { 
	arr* p= ARR(a);
	p->rc ++; 

P("@alink %lu -> %d\n", a, p->rc );
}

void aunlink(thingy a) { 
	arr* p= ARR(a);
	int k;
	int i;
P("@aunlink %lu <- (%d)\n", a, p->rc );

	if (p->rc > 0) {
		-- p->rc;
	} else {
		ASSERT( p->rc==0 );

		for (i=0; i<p->cap; i++) {
			if (ISPTR(p->p[i])) aunlink(p->p[i]);
		}
		freez( p->p, p->cap * sizeof(thingy) );

		freez( p, sizeof *p );
	}
}

int apostincr( th a, th i ) {
	th y= aget(a,i);
	int x= INT(y);
	aput( a, i, (x+1)&MAXINT );
	return x;
}

#define ASTACK_LEN_SLOT	    1
#define ASTACK_BEGIN_SLOT   2
#define ASTACK_MAX	    (MAXINT - ASTACK_BEGIN_SLOT)

void apush( th a, th x )
{
	arr* p= ARR(a);
	int len= INT( p->p[ ASTACK_LEN_SLOT ] );

P("*PUSH(%lu) <- %lu\n", a,  x );

	if ( len >= ASTACK_MAX ) bomb("stack-full",a);
	aput( a, len + ASTACK_BEGIN_SLOT, x );

	len= MAXINT & (len+1);  // not necc if above if is right
	p->p[ ASTACK_LEN_SLOT ] = len;
}

th apop( th a )
{
	th z;
	arr* p= ARR(a);
	int len= INT( p->p[ ASTACK_LEN_SLOT ] );

	if (len==0) return( 0 );
	adump( a,0 );

	len= MAXINT & (len-1);  // not necc if above if is right
	z= aget( a, ASTACK_BEGIN_SLOT+len );
P("*POP(%lu) -> %lu\n", a, z );

	aput( a, ASTACK_BEGIN_SLOT+len, 0 );
	aput( a, ASTACK_LEN_SLOT, len );
	return( z );
}

void adump(th a, int verbose) {
	int i,k;
	if (verbose) ++debug;
	arr* p= ARR(a);

	P("@ %ld rc=%d cap=%d   ", (th)p, p->rc, p->cap ); 

	int cap= p->cap;
	for (i=0; i<cap; i++) {
		if (p->p[i]) {
			th aa= p->p[i];
			if ( 32<=(i) && (i)<=126 ) {
				P( " `%c'%d:", i, i );
			} else {
				P( " %d:", i );
			}
			if ( aa<32 ) {
				P( "%ld", aa );
			} else if ( 32<=aa && aa<=126 ) {
				P( "%ld`%c'", aa , aa );
			} else if ( aa < 256*256 ) {
				P( "%ld\\%c%c", aa , hi(aa),lo(aa) );
			} else {
				P( "%ld", aa );
			}
		}
	}

	P( "\n" );
	if (verbose) --debug;
}
