/* UniThorpe <strick@yak.net> GnuGPL */

#include <stdio.h>
#include <stdlib.h>
#include <malloc.h>
#include <string.h>

int debug;

#define P if(debug)printf

typedef	unsigned long	thingy;
typedef	thingy	th;

#define T16 0x10000
#define MAXINT 0x0FFFF

#define ISINT(x) ( ((thingy)(x)) <T16)
#define ISPTR(x) ( ((thingy)(x)) >=T16)

#define ARR(x) ( ISPTR(x) ? (arr*)(x) : (arr*)(bomb("not_a_ptr", x)) )
#define INT(x) ( ISINT(x) ? (int)(x) : (int)(bomb("not_an_int", x)) )

#define ASSERT(X) ( (X) ? 0 : (int)(bomb(__FILE__,__LINE__)) );

//#define CHANGE(T,X) { if (ISPTR(T) && (T)!=(X) ) { aunlink(T); (T)=(X); if (ISPTR(T) && (T)!=(X) ) link(T); } 

#define CHANGE(T,X) { if ((T)!=(X)) { if (ISPTR(T)) aunlink(T); if (ISPTR(X)) alink(X); } (T)=(X); } 

#define HILO(X,Y) ( (((X)<<8)&0xFF00) | (Y&0xFF) )


typedef struct arr arr;

struct arr {
	int	rc;
	int	cap;
	thingy	*p;
} ;

#define C_KP	1001	/* kode pointer */
#define C_PC	1002	/* program counter */
#define C_SP	1003 	/* stack pointer */
#define C_PROC	';' 	/* proc marker */
#define C_STAT	1005 	/* exit status variable */
#define C_ELIHW	1006 	/* opcode: end-while */
#define C_FI	1007 	/* opcode: end-if */

#define C_IF	'?'
#define C_WHILE	'@'
#define C_CATCH	'~'
#define C_FOR	'#'

#define C_EQ	HILO('e','q')
#define C_NE	HILO('n','e')
#define C_LT	HILO('l','t')
#define C_LE	HILO('l','e')
#define C_GT	HILO('g','t')
#define C_GE	HILO('g','e')

#define C_CHAR_P	HILO('c','?')
#define C_ARRAY_P	HILO('a','?')

#define GetPC aget(G,C_PC)
#define GetKP aget(G,C_KP)
#define GetSP aget(G,C_SP)

#define PutPC(X) aput(G,C_PC,(X))
#define PutKP(X) aput(G,C_KP,(X))
#define PutSP(X) aput(G,C_SP,(X))


/* stack defs */
#define ASTACK_LEN_SLOT     1
#define ASTACK_BEGIN_SLOT   2
#define ASTACK_MAX          (MAXINT - ASTACK_BEGIN_SLOT)


extern	thingy bomb(char* s, thingy x);
extern	void* alloc(int n);
extern	void freez(void* p, int n);
extern	thingy anew();
extern	thingy aget(thingy a, thingy i);
extern	void aput(thingy a, thingy i, thingy x);
extern	void alink(thingy a);
extern	void aunlink(thingy a);
extern	int apostincr( th a, th i );
extern	void apush( th a, th x );
extern	th apop( th a );
extern	void adump( th a, int verbose );

extern	void bc_init(th G);
extern	int loop(thingy G, int start);

//END
